#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
};

uniform float time;

in vec4 position;	// local space

out vec4 color;

//----------------------------------------------------------------
// TODO:
// 1) Flatten y-coordinate to 0.
// 2) Flatten y-coordinate according to time:
//	- sin(time) x abs(sin(time))
//----------------------------------------------------------------

void main()
{
	color = vec4(vec3(0.f), 1.f);
	vec4 v = position;
#if 0
	v.y = 0.f;
#elif 0
	v.y = v.y * sin(time);
#else
	v.y = v.y * abs(sin(time));
#endif
	gl_Position = m_pvm * v;
}