#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
};

uniform float time;

in vec4 position;	// local space
in vec3 normal;		// local space

out vec4 color;

//----------------------------------------------------------------
// TODO:
// 1) Morphing as interpolation between two points (object and sphere).
// 2) Visualize time (interpolation / extrapolation).
// 3) Prevent extrapolation - e.g. use sin function.
//----------------------------------------------------------------

void main()
{
	color = vec4(vec3(0.f), 1.f);

	vec3 sph = position.xyz;
	// Base distance
	float tC = length(sph);

	// Move along the normalized vector from the center to the point.
	vec4 v = position;
#if 0
	v.xyz = normalize(sph) * mix(tC, 1.f, time);
#elif 0
	v.xyz = normalize(sph) * mix(tC, 1.f, sin(time));
#else
	v.xyz = normalize(sph) * mix(tC, 1.f, abs(sin(time)));
#endif
	gl_Position = m_pvm * v;

#if 0
	if(time > 1.f)
		color = vec4(1.f, 0.f, 0.f, 1.f);
	else
		color = vec4(0.f, 1.f, 0.f, 1.f);
#endif
}